/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GorgiasConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GorgiasConnectorForm{}

// GorgiasConnectorForm struct for GorgiasConnectorForm
type GorgiasConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Label of the source
	Label string `json:"label"`
	// URL of the request
	Url string `json:"url"`
	// HTTP Method of the request
	Method string `json:"method"`
	// HTTP Headers of the request
	Headers []interface{} `json:"headers,omitempty"`
	// HTTP Body of the request
	Body *string `json:"body,omitempty"`
	// Tranformation pipeline of the request
	Transformation string `json:"transformation"`
	// Emitter pipeline of the request
	Emitter *string `json:"emitter,omitempty"`
	// Authorizer ID
	OAuthId string `json:"oAuthId"`
	// Custom params replacing placeholders in the request
	Parameters []string `json:"parameters,omitempty"`
	// Final selections of the attributes to be included in the source
	Attributes []string `json:"attributes"`
}

// NewGorgiasConnectorForm instantiates a new GorgiasConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGorgiasConnectorForm(connectorId string, templateId string, strategy string, label string, url string, method string, transformation string, oAuthId string, attributes []string) *GorgiasConnectorForm {
	this := GorgiasConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.Label = label
	this.Url = url
	this.Method = method
	this.Transformation = transformation
	this.OAuthId = oAuthId
	this.Attributes = attributes
	return &this
}

// NewGorgiasConnectorFormWithDefaults instantiates a new GorgiasConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGorgiasConnectorFormWithDefaults() *GorgiasConnectorForm {
	this := GorgiasConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *GorgiasConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *GorgiasConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *GorgiasConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *GorgiasConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *GorgiasConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *GorgiasConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *GorgiasConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *GorgiasConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *GorgiasConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetLabel returns the Label field value
func (o *GorgiasConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *GorgiasConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetUrl returns the Url field value
func (o *GorgiasConnectorForm) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *GorgiasConnectorForm) SetUrl(v string) {
	o.Url = v
}

// GetMethod returns the Method field value
func (o *GorgiasConnectorForm) GetMethod() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Method
}

// GetMethodOk returns a tuple with the Method field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetMethodOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Method, true
}

// SetMethod sets field value
func (o *GorgiasConnectorForm) SetMethod(v string) {
	o.Method = v
}

// GetHeaders returns the Headers field value if set, zero value otherwise.
func (o *GorgiasConnectorForm) GetHeaders() []interface{} {
	if o == nil || IsNil(o.Headers) {
		var ret []interface{}
		return ret
	}
	return o.Headers
}

// GetHeadersOk returns a tuple with the Headers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetHeadersOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Headers) {
		return nil, false
	}
	return o.Headers, true
}

// HasHeaders returns a boolean if a field has been set.
func (o *GorgiasConnectorForm) HasHeaders() bool {
	if o != nil && !IsNil(o.Headers) {
		return true
	}

	return false
}

// SetHeaders gets a reference to the given []interface{} and assigns it to the Headers field.
func (o *GorgiasConnectorForm) SetHeaders(v []interface{}) {
	o.Headers = v
}

// GetBody returns the Body field value if set, zero value otherwise.
func (o *GorgiasConnectorForm) GetBody() string {
	if o == nil || IsNil(o.Body) {
		var ret string
		return ret
	}
	return *o.Body
}

// GetBodyOk returns a tuple with the Body field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetBodyOk() (*string, bool) {
	if o == nil || IsNil(o.Body) {
		return nil, false
	}
	return o.Body, true
}

// HasBody returns a boolean if a field has been set.
func (o *GorgiasConnectorForm) HasBody() bool {
	if o != nil && !IsNil(o.Body) {
		return true
	}

	return false
}

// SetBody gets a reference to the given string and assigns it to the Body field.
func (o *GorgiasConnectorForm) SetBody(v string) {
	o.Body = &v
}

// GetTransformation returns the Transformation field value
func (o *GorgiasConnectorForm) GetTransformation() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Transformation
}

// GetTransformationOk returns a tuple with the Transformation field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetTransformationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Transformation, true
}

// SetTransformation sets field value
func (o *GorgiasConnectorForm) SetTransformation(v string) {
	o.Transformation = v
}

// GetEmitter returns the Emitter field value if set, zero value otherwise.
func (o *GorgiasConnectorForm) GetEmitter() string {
	if o == nil || IsNil(o.Emitter) {
		var ret string
		return ret
	}
	return *o.Emitter
}

// GetEmitterOk returns a tuple with the Emitter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetEmitterOk() (*string, bool) {
	if o == nil || IsNil(o.Emitter) {
		return nil, false
	}
	return o.Emitter, true
}

// HasEmitter returns a boolean if a field has been set.
func (o *GorgiasConnectorForm) HasEmitter() bool {
	if o != nil && !IsNil(o.Emitter) {
		return true
	}

	return false
}

// SetEmitter gets a reference to the given string and assigns it to the Emitter field.
func (o *GorgiasConnectorForm) SetEmitter(v string) {
	o.Emitter = &v
}

// GetOAuthId returns the OAuthId field value
func (o *GorgiasConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *GorgiasConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetParameters returns the Parameters field value if set, zero value otherwise.
func (o *GorgiasConnectorForm) GetParameters() []string {
	if o == nil || IsNil(o.Parameters) {
		var ret []string
		return ret
	}
	return o.Parameters
}

// GetParametersOk returns a tuple with the Parameters field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetParametersOk() ([]string, bool) {
	if o == nil || IsNil(o.Parameters) {
		return nil, false
	}
	return o.Parameters, true
}

// HasParameters returns a boolean if a field has been set.
func (o *GorgiasConnectorForm) HasParameters() bool {
	if o != nil && !IsNil(o.Parameters) {
		return true
	}

	return false
}

// SetParameters gets a reference to the given []string and assigns it to the Parameters field.
func (o *GorgiasConnectorForm) SetParameters(v []string) {
	o.Parameters = v
}

// GetAttributes returns the Attributes field value
func (o *GorgiasConnectorForm) GetAttributes() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value
// and a boolean to check if the value has been set.
func (o *GorgiasConnectorForm) GetAttributesOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Attributes, true
}

// SetAttributes sets field value
func (o *GorgiasConnectorForm) SetAttributes(v []string) {
	o.Attributes = v
}

func (o GorgiasConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GorgiasConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["label"] = o.Label
	toSerialize["url"] = o.Url
	toSerialize["method"] = o.Method
	if !IsNil(o.Headers) {
		toSerialize["headers"] = o.Headers
	}
	if !IsNil(o.Body) {
		toSerialize["body"] = o.Body
	}
	toSerialize["transformation"] = o.Transformation
	if !IsNil(o.Emitter) {
		toSerialize["emitter"] = o.Emitter
	}
	toSerialize["oAuthId"] = o.OAuthId
	if !IsNil(o.Parameters) {
		toSerialize["parameters"] = o.Parameters
	}
	toSerialize["attributes"] = o.Attributes
	return toSerialize, nil
}

type NullableGorgiasConnectorForm struct {
	value *GorgiasConnectorForm
	isSet bool
}

func (v NullableGorgiasConnectorForm) Get() *GorgiasConnectorForm {
	return v.value
}

func (v *NullableGorgiasConnectorForm) Set(val *GorgiasConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableGorgiasConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableGorgiasConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGorgiasConnectorForm(val *GorgiasConnectorForm) *NullableGorgiasConnectorForm {
	return &NullableGorgiasConnectorForm{value: val, isSet: true}
}

func (v NullableGorgiasConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGorgiasConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
